"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tennis_game_1 = require("./tennis-game");
var src_1 = require("../../src");
describe('Tennis game', function () {
    var game;
    beforeEach(function () {
        game = (0, tennis_game_1.createGame)('Foo', 'Bar');
    });
    describe('when in new game state', function () {
        it('has right score', function () {
            var score = game.getScore();
            expect(score).toBe('Love all');
        });
    });
    describe('when player one wins first ball', function () {
        it('has right score', function () {
            game.playerOneScores();
            var score = game.getScore();
            expect(score).toBe('Fifteen,Love');
        });
    });
    describe('when both fifteen', function () {
        it('has right score', function () {
            game.playerOneScores();
            game.playerTwoScores();
            var score = game.getScore();
            expect(score).toBe('Fifteen all');
        });
    });
    describe('when player one wins first three balls', function () {
        it('has right score', function () {
            setScore(game, 3, 0);
            var score = game.getScore();
            expect(score).toBe('Forty,Love');
        });
    });
    describe('when players are deuce', function () {
        it('has right score', function () {
            setScore(game, 3, 3);
            var score = game.getScore();
            expect(score).toBe('Deuce');
        });
    });
    describe('when player one wins the game', function () {
        it('has right score', function () {
            setScore(game, 4, 0);
            var score = game.getScore();
            expect(score).toBe('Foo wins');
        });
    });
    describe('when player two wins the game', function () {
        it('has right score', function () {
            setScore(game, 1, 4);
            var score = game.getScore();
            expect(score).toBe('Bar wins');
        });
    });
    describe('when players are deuce 4', function () {
        it('has right score', function () {
            setScore(game, 4, 4);
            var score = game.getScore();
            expect(score).toBe('Deuce');
        });
    });
    describe('when player two has advantage', function () {
        it('has right score', function () {
            setScore(game, 4, 5);
            var score = game.getScore();
            expect(score).toBe('Advantage Bar');
        });
    });
    describe('when player one has advantage', function () {
        it('has right score', function () {
            setScore(game, 5, 4);
            var score = game.getScore();
            expect(score).toBe('Advantage Foo');
        });
    });
    describe('when player two wins after advantage', function () {
        it('has right score', function () {
            setScore(game, 6, 8);
            var score = game.getScore();
            expect(score).toBe('Bar wins');
        });
    });
    describe('when player one wins after advantage', function () {
        it('has right score', function () {
            setScore(game, 8, 6);
            var score = game.getScore();
            expect(score).toBe('Foo wins');
        });
    });
    var setScore = function (game, p1Score, p2Score) {
        (0, src_1.repeat)(p1Score, game.playerOneScores);
        (0, src_1.repeat)(p2Score, game.playerTwoScores);
    };
});
//# sourceMappingURL=tennis-game.test.js.map