"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.left = exports.right = exports.leftOf = exports.rightOf = exports.isEither = void 0;
var react_1 = __importDefault(require("fast-deep-equal/es6/react"));
var serializer_1 = require("./serializer");
var PROTOTYPE = {};
var isEither = function (input) {
    try {
        return Object.getPrototypeOf(input) === PROTOTYPE;
    }
    catch (_) {
        return false;
    }
};
exports.isEither = isEither;
var seal = function (adt) { return Object.freeze(Object.assign(Object.create(PROTOTYPE), adt)); };
var createRight = function (data) {
    return seal(__assign(__assign({}, (0, serializer_1.createSerializable)('Right', data)), { isLeft: false, isRight: true, equals: function (operand) {
            return operand.fold(function () { return false; }, function (it) { return (0, react_1.default)(it, data); });
        }, fold: function (_, ifRight) { return ifRight(data); }, getOrElse: function () { return data; }, flatMap: function (ifRight) { return (0, exports.rightOf)(ifRight(data)); }, mapLeft: function () { return (0, exports.rightOf)(data); } }));
};
var createLeft = function (data) {
    var fold = function (ifLeft) { return ifLeft(data); };
    return seal(__assign(__assign({}, (0, serializer_1.createSerializable)('Left', data)), { isLeft: true, isRight: false, equals: function (operand) {
            return operand.fold(function (it) { return (0, react_1.default)(it, data); }, function () { return false; });
        }, fold: fold, getOrElse: fold, flatMap: function () { return (0, exports.leftOf)(data); }, mapLeft: function (ifLeft) { return (0, exports.leftOf)(ifLeft(data)); } }));
};
var rightOf = function (data) { return ((0, exports.isEither)(data) ? data : createRight(data)); };
exports.rightOf = rightOf;
var leftOf = function (data) { return ((0, exports.isEither)(data) ? data : createLeft(data)); };
exports.leftOf = leftOf;
var right = function (value) { return createRight(value); };
exports.right = right;
var left = function (value) { return createLeft(value); };
exports.left = left;
//# sourceMappingURL=either.js.map