"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.partition = exports.tryCatch = void 0;
var either_1 = require("./either");
var tryCatch = function (tryFn) {
    try {
        return (0, either_1.right)(tryFn());
    }
    catch (e) {
        return (0, either_1.left)(e);
    }
};
exports.tryCatch = tryCatch;
var partition = function (array) {
    var seed = [[], []];
    return array.reduce(function (acc, item) {
        var lefts = acc[0], rights = acc[1];
        if (item.isLeft)
            lefts.push(item);
        if (item.isRight)
            rights.push(item);
        return acc;
    }, seed);
};
exports.partition = partition;
//# sourceMappingURL=either.utils.js.map