"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSerializable = void 0;
var lambda_1 = require("../lambda/lambda");
var either_1 = require("./either");
var isError = function (data) {
    if (data instanceof Error)
        return true;
    try {
        return Object.getPrototypeOf(data) === Error.prototype;
    }
    catch (_) {
        return false;
    }
};
var wrap = function (variant, serialized) { return "".concat(variant, "(").concat(serialized, ")"); };
var stringify = function (value) {
    if (isError(value))
        return "".concat(value.name, "(\"").concat(value.message, "\")");
    if ((0, either_1.isEither)(value)) {
        var variant = value.isRight ? 'Right' : 'Left';
        return wrap(variant, value.fold(function () { return ''; }, stringify));
    }
    return JSON.stringify(value);
};
var toJSON = function () {
    console.warn("Either values can't be serialized to JSON. Please, \"fold\" them first.");
    return {};
};
var createSerializable = function (variant, value) { return ({
    toString: (0, lambda_1.constant)(function () { return wrap(variant, stringify(value)); }),
    toJSON: toJSON,
}); };
exports.createSerializable = createSerializable;
//# sourceMappingURL=serializer.js.map