"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jest_matcher_utils_1 = require("jest-matcher-utils");
var either_1 = require("./either/either");
var maybe_1 = require("./maybe/maybe");
var getValueCheckResults = function (fnName, values, pass) { return ({
    pass: pass,
    message: function () {
        var matcher = "".concat(pass ? '.not' : '', ".").concat(fnName);
        return [(0, jest_matcher_utils_1.matcherHint)(matcher), '', (0, jest_matcher_utils_1.diff)(values.expected.toString(), values.received.toString())].join('\n');
    },
}); };
var equals = function (values) { return values.received.equals(values.expected); };
var toBeRight = function (received, expected) {
    var values = { expected: (0, either_1.rightOf)(expected), received: (0, either_1.rightOf)(received) };
    var pass = equals(values);
    return getValueCheckResults('toBeRight', values, pass);
};
var toBeLeft = function (received, expected) {
    var values = { expected: (0, either_1.leftOf)(expected), received: (0, either_1.leftOf)(received) };
    var pass = equals(values);
    return getValueCheckResults('toBeLeft', values, pass);
};
var toBeNothing = function (received) {
    var values = { expected: (0, maybe_1.nothing)(), received: (0, either_1.leftOf)(received) };
    var pass = equals(values);
    return getValueCheckResults('toBeNothing', values, pass);
};
expect.extend({
    toBeRight: toBeRight,
    toBeLeft: toBeLeft,
    toBeNothing: toBeNothing,
});
//# sourceMappingURL=jest-matchers.js.map