"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.maybeLast = exports.maybeFirst = exports.noop = exports.chunk = exports.rotate = exports.repeat = exports.constant = void 0;
var maybe_1 = require("../maybe/maybe");
var constant = function (fn) {
    var cache;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (cache) {
            return cache;
        }
        else {
            cache = fn.apply(void 0, args);
            return cache;
        }
    };
};
exports.constant = constant;
var createArray = function (times) { return Array(times).fill(undefined); };
var repeat = function (times, factory) { return createArray(times).map(function (_, i) { return factory(i); }); };
exports.repeat = repeat;
var rotate = function (n, arr) { return arr.slice(n, arr.length).concat(arr.slice(0, n)); };
exports.rotate = rotate;
var chunk = function (size, arr) {
    return (0, exports.repeat)(Math.ceil(arr.length / size), function (index) { return index * size; }).map(function (begin) { return arr.slice(begin, begin + size); });
};
exports.chunk = chunk;
var noop = function () { };
exports.noop = noop;
var maybeFirst = function (array) { return (0, maybe_1.maybe)(array[0]); };
exports.maybeFirst = maybeFirst;
var maybeLast = function (array) { return (0, maybe_1.maybe)(array[array.length - 1]); };
exports.maybeLast = maybeLast;
//# sourceMappingURL=lambda.js.map